* AUXILLIARY DO FILE
* BOOTSTRAPPING MEANS AND STANDARD DEVIATIONS
* THIS FILES GETS RUN FROM MAIN.DO, WHERE THE DATA GETS LOADED AND ITS GLOBALS ARE DEFINED 

* 1. GET ACTUAL VALUES
* mean O
sum O
scalar Omean 	= r(mean)
scalar Osd		= r(sd)

* mean n_O
sum Op
scalar Opmean 	= r(mean)
scalar Opsd		= r(sd)

capture drop matrix observed
matrix observed = Omean,Osd,Opmean,Opsd
	

* 2. PROGRAM TO BOOTSTRAP
global j=2
capture program drop myboot2
program define myboot2, rclass
	preserve
		* create new O and Op
		*local i=floor(2+runiform()*50) would take a random integer 2-51 (1=original sample), but then some get repeated
		local i = $j // trial with i=1 (original omega)
		*
		estimates use "$output\betas", number(`i')
		gen est=`i'
		merge m:1 n_HHID est using "$output\epsilons", assert(2 3) keep(3) nogen
		predict double Pp 
		gen O  = Pp + res - n_lnconspc
		gen Op = Pp 	  - n_lnconspc 	// omega prime from manuscript
		* flip to get corresponding n_O and n_Op
		tempfile temp
		save `temp', replace
		keep HHID n_HHID O Op
		ren HHID tHHID
		ren n_HHID HHID
		ren tHHID n_HHID
		ren O  n_O
		ren Op n_Op
		merge 1:1 HHID n_HHID using `temp', keep(2 3) nogen
		* take bootstrap sample
		bsample
		* mean and sd
		sum O
		return scalar Omean 	= r(mean)
		return scalar Osd		= r(sd)
		sum Op
		return scalar Opmean	= r(mean)
		return scalar Opsd		= r(mean)
	restore
	global j = $j+1
end

* 3. REPEAT PROGRAM X TIMES - SET ITERATIONS HERE - also change reps above on line 324
macro dir // this is just so you can quickly see which iteration we're on
capture drop Pp-Op
capture timer clear 1
timer on 1
simulate Omean=r(Omean) Osd=r(Osd) ///
		 Opmean=r(Opmean) Opsd=r(Opsd) , reps($iterations) seed(745651): myboot2 
timer off 1

* 4. CREATE AND SHOW BOOSTRAPPED RESULTS
bstat, stat(observed) n(9032)
timer list 1
di r(t1)/60

